/*
 *  INTERPRETER, {akii-root}/src/interpreter.h
 *
 * ==========================================================================
 *
 *                      Arena Kliens II. Releases
 *
 * ==========================================================================
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * A legkiralyabb szovegszerkeszto: VIM - Vi IMproved 5  <http://www.vim.org>
 */

#ifndef _INTERPRETER_H_
#define _INTERPRETER_H_ 1

#include "expression.h"

#define PARANCS_EGY             0
#define PARANCS_SOR_NOKAPOCS    1
#define PARANCS_SOR_KAPOCS      2
#define PARANCS_EGY_NOVALASZ    3

#define DO_BREAK        -1
#define DO_CONTINUE     -2
#define DO_RETURN       -3
#define DO_ESCAPE       -4
#define DO_NEXTON       -5
#define DO_NOMOREON     -6

enum parenum {
    PAR_KIF, PAR_ON, PAR_ONSEND, PAR_IF, PAR_WHILE, PAR_FOR, PAR_DO,
    PAR_FOREACH, PAR_ALIAS, PAR_BREAK, PAR_CONTINUE, PAR_TIMER, PAR_RETURN,
    PAR_ESCAPE, PAR_CHECKPOINT, PAR_NEXTON, PAR_NOMOREON
};

struct parancs {
    enum parenum tipus;		/*PAR_... */
    void *ertek;		/*a `par'-tol fugg, hogy micsoda */
    int refnum;			/*referenciaszam (ha 0, torolheto) */
    struct parancs *prev, *next;
};
struct onstruct {
    char *nev;
    char tipus;
    int szint;
    int kifek;
    char **regkifek;
    struct parancs *par;
};
struct timerstruct {
    char *nev;
    char tipus;			/*ha a tipus 1 vagy 2 ( ~ v. ! ), akkor az ido egy valtozonev */
    char *ido;			/*ha a tipus ~ vagy ! akkor az ido egy szam! */
    struct parancs *par;
};
struct wstruct {
    struct kif *kif;
    struct parancs *par;
};
struct ifstruct {
    struct kif *kif;
    struct parancs *par, *elsepar;
};
struct foreachstruct {
    char *tomb;
    char *inev;
    struct parancs *par;
};
struct forstruct {
    struct kif *kifek[3];
    struct parancs *par;
};
struct aliasstruct {
    char *nev;
    int cpnum;
    char **cps;
    struct parancs *par;
};
struct aliasstr {
    int cpnum;
    char **cps;
    struct parancs *par;
};

extern struct parancs *readparancs(char **, int, int);	/*parancs(sor) beolvasasa */
extern void resetsoroszlop(int);	/*sor, oszlop valtozok nullazasa */
extern int doparancssor(struct parancs *);	/*a parancssor vegrehajtasa */

extern void *freepar(struct parancs *);		/*parancssor torlese */

extern struct valtozo *akii_novice;
extern int novice;
extern int nexton_level, checkpoint_level, brkcnt_level;

#endif
